> For the complete documentation index, see [llms.txt](https://docs.zkbob.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.zkbob.com/implementation/client-library-sdk/full-mode-operations/transaction-maintenance.md).

# Transaction Maintenance

The relayer queues, verifies and sends your transaction upon receipt. It can take up to several minutes. To be able to track the transaction statuses the relayer provides you a job ID for each received transaction. You can use it in the following methods

## <mark style="background-color:green;">Waiting Transactions Send to the Pool</mark>

Waiting all provided jobs to be sent to the pool contract

```typescript
async waitJobsTxHashes(jobIds: string[]): Promise<{jobId: string, txHash: string}[]>
```

The corresponding version for single job ID is also available:

```typescript
async waitJobTxHash(jobId: string): Promise<string>
```

### Parameters

`jobIds` - array of job identifiers or

`jobId` - job identifiers

### Returns

`Promise` returns the array of objects where jobId is one of requested jobs and txHash - transaction hash associated with that job (or just a txHash for `waitJobTxHash`)

### Example

```typescript
const res = await zkAccount.waitJobsTxHashes(['123', '124']);
console.log(`Done ${res.map((j) => `job #${j.jobId}: ${j.txHash}`).join(`\n`)}`);
// output:
// job #123: 0xf1fcf095b4cfd9bda5b18024acf6a1fdf6d9e040a1ec4abed140088b802f73df
// job #124: 0xd5e8960bad7f5964dd3cf3c8853b33e4368c3ec4f3626ef1ea546b5405deeb58
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.zkbob.com/implementation/client-library-sdk/full-mode-operations/transaction-maintenance.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
